# CollectionViewPagingLayout

[![License](https://img.shields.io/cocoapods/l/CollectionViewPagingLayout.svg?style=flat)](http://cocoapods.org/pods/CollectionViewPagingLayout)
![platforms](https://img.shields.io/badge/platforms-iOS-333333.svg)
[![pod](https://img.shields.io/cocoapods/v/CollectionViewPagingLayout.svg)](https://cocoapods.org/pods/CollectionViewPagingLayout)
[![Carthage compatible](https://img.shields.io/badge/Carthage-compatible-4BC51D.svg?style=flat)](https://github.com/Carthage/Carthage) 
[![Swift Package Manager compatible](https://img.shields.io/badge/Swift%20Package%20Manager-compatible-brightgreen.svg)](https://github.com/apple/swift-package-manager)

## Previews

### Layout Designer
[<img width="600" src="https://amir.app/git/layout_designer_preview.gif">](https://apps.apple.com/nl/app/layout-designer/id1507238011?l=en&mt=12)   
<a href="https://apps.apple.com/nl/app/layout-designer/id1507238011?l=en&mt=12"> <img width="100" src="http://amir.app/git/app_store.png"></img> </a>    


#### Custom implementations, UIKit: `TransformableView`, SwiftUI: `TransformPageView`
Click on image to see the code

<p float="left">

[<img width="120" src="https://amir.app/git/flowlayout_preview.gif">](https://github.com/amirdew/CollectionViewPagingLayout/tree/master/Samples/PagingLayoutSamples/Modules/UIKit/Fruits)
[<img width="120" src="https://amir.app/git/gallery_preview.gif">](https://github.com/amirdew/CollectionViewPagingLayout/tree/master/Samples/PagingLayoutSamples/Modules/UIKit/Gallery)
[<img width="120" src="https://amir.app/git/cards_preview.gif">](https://github.com/amirdew/CollectionViewPagingLayout/tree/master/Samples/PagingLayoutSamples/Modules/UIKit/Cards)
<p />

#### UIKit: `SnapshotTransformView`, SwiftUI: `SnapshotPageView`


<p float="left">

[<img width="100" src="https://amir.app/git/shapes_preview/snapshot_grid.gif">](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Snapshot/SnapshotTransformViewOptions%2BLayout.swift#L14) 
[<img width="100" src="https://amir.app/git/shapes_preview/snapshot_space.gif">](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Snapshot/SnapshotTransformViewOptions%2BLayout.swift#L15) 
[<img width="100" src="https://amir.app/git/shapes_preview/snapshot_chess.gif">](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Snapshot/SnapshotTransformViewOptions%2BLayout.swift#L16) 
[<img width="100" src="https://amir.app/git/shapes_preview/snapshot_tiles.gif">](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Snapshot/SnapshotTransformViewOptions%2BLayout.swift#L17) 
[<img width="100" src="https://amir.app/git/shapes_preview/snapshot_lines.gif">](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Snapshot/SnapshotTransformViewOptions%2BLayout.swift#L18) 
[<img width="100" src="https://amir.app/git/shapes_preview/snapshot_bars.gif">](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Snapshot/SnapshotTransformViewOptions%2BLayout.swift#L19) 
[<img width="100" src="https://amir.app/git/shapes_preview/snapshot_puzzle.gif">](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Snapshot/SnapshotTransformViewOptions%2BLayout.swift#L20) 
[<img width="100" src="https://amir.app/git/shapes_preview/snapshot_fade.gif">](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Snapshot/SnapshotTransformViewOptions%2BLayout.swift#L21) 
</p>

         
#### UIKit: `ScaleTransformView`, SwiftUI: `ScalePageView`
<p float="left">

[<img width="100" src="https://amir.app/git/shapes_preview/scale_invertedcylinder.gif"></img>](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Scale/ScaleTransformViewOptions%2BLayout.swift#L14)
[<img width="100" src="https://amir.app/git/shapes_preview/scale_cylinder.gif"></img>](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Scale/ScaleTransformViewOptions%2BLayout.swift#L15)
[<img width="100" src="https://amir.app/git/shapes_preview/scale_coverflow.gif"></img>](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Scale/ScaleTransformViewOptions%2BLayout.swift#L16)
[<img width="100" src="https://amir.app/git/shapes_preview/scale_rotary.gif"></img>](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Scale/ScaleTransformViewOptions%2BLayout.swift#L17)
[<img width="100" src="https://amir.app/git/shapes_preview/scale_linear.gif"></img>](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Scale/ScaleTransformViewOptions%2BLayout.swift#L18)
[<img width="100" src="https://amir.app/git/shapes_preview/scale_easein.gif"></img>](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Scale/ScaleTransformViewOptions%2BLayout.swift#L19)
[<img width="100" src="https://amir.app/git/shapes_preview/scale_easeout.gif"></img>](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Scale/ScaleTransformViewOptions%2BLayout.swift#L20)
[<img width="100" src="https://amir.app/git/shapes_preview/scale_blur.gif"></img>](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Scale/ScaleTransformViewOptions%2BLayout.swift#L21)
</p>

### UIKit: `StackTransformView`, SwiftUI: `StackPageView`

<p float="left">

[<img width="100" src="https://amir.app/git/shapes_preview/stack_transparent.gif"></img>](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Stack/StackTransformViewOptions%2BLayout.swift#L14)
[<img width="100" src="https://amir.app/git/shapes_preview/stack_blur.gif"></img>](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Stack/StackTransformViewOptions%2BLayout.swift#L15)
[<img width="100" src="https://amir.app/git/shapes_preview/stack_perspective.gif"></img>](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Stack/StackTransformViewOptions%2BLayout.swift#L16)
[<img width="100" src="https://amir.app/git/shapes_preview/stack_reverse.gif"></img>](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Stack/StackTransformViewOptions%2BLayout.swift#L17)
[<img width="100" src="https://amir.app/git/shapes_preview/stack_rotary.gif"></img>](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Stack/StackTransformViewOptions%2BLayout.swift#L18)
[<img width="100" src="https://amir.app/git/shapes_preview/stack_vortex.gif"></img>](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/Lib/Stack/StackTransformViewOptions%2BLayout.swift#L19)
</p>


## About

**`UIKit:`**  
A simple but powerful framework that lets you make complex layouts for your `UICollectionView`.        
The implementation is quite simple. Just a custom `UICollectionViewLayout` that gives you the ability to apply transforms to the cells.       
No UICollectionView inheritance or anything like that.             

**`SwiftUI:`**  
A simple `View` that lets you make page-view effects.   
Powered by `UICollectionView`
     
     
    
<br>

For more details, see [How to use](https://github.com/amirdew/CollectionViewPagingLayout#how-to-use)   

## Installation
This framework doesn't contain any external dependencies.

#### [CocoaPods](https://guides.cocoapods.org/using/using-cocoapods.html)

```ruby
# Podfile
use_frameworks!

target 'YOUR_TARGET_NAME' do
    pod 'CollectionViewPagingLayout'
end
```
Replace `YOUR_TARGET_NAME` and then, in the `Podfile` directory, type:

```bash
$ pod install
```

#### [Carthage](https://github.com/Carthage/Carthage)

Add this to `Cartfile`

```
github "CollectionViewPagingLayout"
```

and then, in the `Cartfile` directory, type:
```bash
$ carthage update
```

#### [Swift Package Manager](https://github.com/apple/swift-package-manager)

using Xcode:

File > Swift Packages > Add Package Dependency

#### Manually
Just add all the files under `Lib` directory to your project

## How to use

### Using [Layout Designer](https://apps.apple.com/nl/app/layout-designer/id1507238011?l=en&mt=1)
      
There is a macOS app to make it even easier for you to build your custom layout.            
It allows you to tweak many options and see the result in real-time.        
It also generates the code for you. So, you can copy it to your project.       

You can [purchase](https://apps.apple.com/nl/app/layout-designer/id1507238011?l=en&mt=1) the app from App Store and support this repository,
or you can build it yourself from the source.  
Yes, the macOS app is open-source too!. 


Continue for [`SiwftUI`](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/HOW_TO_USE_SWIFTUI.md) or [`UIKit`](https://github.com/amirdew/CollectionViewPagingLayout/blob/master/HOW_TO_USE_UIKIT.md)


## Limitations
-  **Specify the number of visible items:**    
You need to specify the number of visible items.       
Since this layout gives you the flexibility to show the next and previous cells,        
By default, it loads all of the cells in the collectionview's frame, which means iOS keeps all of them in the memory.      
Based on your design, you can specify the number of items that you need to show.     

- **It doesn't support RTL layouts:**   
however, you can achieve a similar result by tweaking options, for instance try `StackTransformViewOptions.Layout.reverse`

## License

CollectionViewPagingLayout is available under the MIT license. See LICENSE file for more info.
